"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_2 = require("react");
var CssReset_1 = __importDefault(require("./CssReset"));
var navigationContext_1 = __importDefault(require("./navigationContext"));
var NavigationProvider = navigationContext_1.default.Provider;
var createProxy = function (fn) {
    var proxy = new Proxy({}, {
        get: function (_, query) {
            if (typeof query === "symbol")
                throw new Error("Invalid query");
            try {
                return fn(query).toString();
            }
            catch (_a) {
                return query;
            }
        },
    });
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return proxy;
};
var processTheme = function (theme) {
    return (__assign(__assign({}, theme), { s: createProxy(theme.size), c: createProxy(theme.color) }));
};
var SpecimenProvider = function (_a) {
    var _b;
    var theme = _a.theme, _c = _a.cssReset, cssReset = _c === void 0 ? true : _c, props = __rest(_a, ["theme", "cssReset"]);
    var processedTheme = (0, react_2.useMemo)(function () { return processTheme(theme); }, [theme]);
    return ((0, jsx_runtime_1.jsxs)(NavigationProvider, __assign({ value: (_b = props.navigationFn) !== null && _b !== void 0 ? _b : null }, { children: [cssReset && (0, jsx_runtime_1.jsx)(CssReset_1.default, {}), (0, jsx_runtime_1.jsx)(react_1.ThemeProvider, __assign({ theme: processedTheme }, { children: props.children }))] })));
};
exports.default = SpecimenProvider;
